/**
 * REXX Communication Control Function Library  Ver.1.9
 *                  copyright 1998-2002, Naga(Kazuo Adachi)
 *                          mailto:nagaw@attglobal.net
 *
 * Test to send control characters(ex.'\xHH','\r',etc.).
 *
 */

CALL RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
CALL SysLoadFuncs

CALL RxFuncAdd 'RxCommLoadFuncs','RxComm','RxCommLoadFuncs'
CALL RxCommLoadFuncs

/* Set a name of com port to access.
 */
comPort = 'COM3'

/* Open com port device.
 */
rc = RxCommOpen( comPort, 115200, '8N1', 'RTS/CTS XON/XOFF' )
IF rc <> 0 THEN
DO
    SAY 'Cannot open com port!!'
    EXIT
END

/* Set to use control characters.
 */
rc = RxCommOption( 'SEND_CTLCH', 'ON' )


/* Test to send control character #1.
 */
rc = RxCommWrite( 'ATZ\xd' )
DO FOREVER
    rc = RxCommRead()
    CALL CHAROUT , rc

    IF POS( 'OK', rc ) > 0 THEN LEAVE
END

/* Test to send control character #2.
 */
rc = RxCommWrite( 'ATZ\x0D' )
DO FOREVER
    rc = RxCommRead()
    CALL CHAROUT , rc

    IF POS( 'OK', rc ) > 0 THEN LEAVE
END

/* Test to send control character #3.
 */
rc = RxCommWrite( 'ATZ\r' )
DO FOREVER
    rc = RxCommRead()
    CALL CHAROUT , rc

    IF POS( 'OK', rc ) > 0 THEN LEAVE
END


rc = RxCommClose()

EXIT
