/**
 * REXX Communication Control Function Library  Ver.1.9
 *                  copyright 1998-2002, Naga(Kazuo Adachi)
 *                          mailto:nagaw@attglobal.net
 *
 * Test to change modem signals and send AT commands.
 *
 */

CALL RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
CALL SysLoadFuncs

CALL RxFuncAdd 'RxCommLoadFuncs','RxComm','RxCommLoadFuncs'
CALL RxCommLoadFuncs

/* Set a name of com port to access.
 */
comPort = 'COM3'

/* Open com port device.(115200bps,8bit,Non-parity,1stop-bit)
 */
rc = RxCommOpen( comPort, 115200, '8N1' )
IF rc <> 0 THEN
DO
    SAY 'Cannot open com port!!'
    EXIT
END

/* Set to use control characters(ex.'\r').
 */
rc = RxCommOption( 'SEND_CTLCH', 'ON' )


SAY 'Let''s Start Communication!!'


/*--------------------------------------------------------*/
/* Read modem signal.
 */
SAY 'Modem Signal(Start) =' RxCommSignal()


/*--------------------------------------------------------*/
/* Send AT command to com port.
 */
rc = RxCommWrite( 'ATZ\r' )
DO FOREVER
    rc = RxCommRead()
    IF rc <> '' THEN
    DO
        CALL CHAROUT , rc

        IF POS( 'OK', rc ) > 0 THEN LEAVE
    END
END


/*--------------------------------------------------------*/
/* Change modem singal and put result.
 */
lineDTR = ''
lineRTS = 'OFF'

SAY 'Modem Signal(Modified) =' RxCommSignal( lineDTR, lineRTS )


/*--------------------------------------------------------*/
/* Send AT command to com port, again.
 */
rc = RxCommWrite( 'ATZ\r' )
DO FOREVER
    rc = RxCommRead( 100 )
    IF rc =  '' THEN LEAVE
    IF rc <> '' THEN
    DO
        CALL CHAROUT , rc

        IF POS( 'OK', rc ) > 0 THEN LEAVE
    END
END


rc = RxCommClose()

EXIT
