/**
 * REXX Communication Control Function Library  Ver.1.9
 *                  copyright 1998-2002, Naga(Kazuo Adachi)
 *                          mailto:nagaw@attglobal.net
 *
 * Get available number of com ports and check com port.
 *
 */

CALL RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
CALL SysLoadFuncs

CALL RxFuncAdd 'RxCommLoadFuncs','RxComm','RxCommLoadFuncs'
CALL RxCommLoadFuncs

/* Get available number of com ports.
 */
maxPort = RxCommPort()
IF 1 < maxPort
  THEN numPort = maxPort || ' ports'
  ELSE numPort = maxPort || ' port'

SAY 'REXX Communication DLL  Version' RxCommGetVersion() '(' numPort ')'

/* Check com ports can use.
 */
DO i = 1 to maxPort
    rc = RxCommPort( 'COM' || i )
    IF 0 = rc THEN SAY 'COM' || i 'cannot use by RxComm.dll.'
END

IF 4 > maxPort THEN
DO i = maxPort+1 to 4
    rc = RxCommPort( 'COM' || i )
    IF 1 = rc THEN SAY 'COM' || i 'can use by RxComm.dll.'
END

