/**
 * REXX Communication Control Function Library  Ver.1.9
 *                  copyright 1998-2002, Naga(Kazuo Adachi)
 *                          mailto:nagaw@attglobal.net
 *
 * Communication test tool for the 'Crossam2+'.
 * see also http://rd.vector.co.jp/vpack/browse/person/an003192.html
 *          http://www.halcorp.co.jp/
 *
 */

CALL RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
CALL SysLoadFuncs

CALL RxFuncAdd 'RxCommLoadFuncs','RxComm','RxCommLoadFuncs'
CALL RxCommLoadFuncs

/**
 * Set Communication port.
 */
comPort = 'COM1'

/*--------------------------------------------------------*/
/**
 * Open COM Port Device.
 */
rc = RxCommOption( 'SEND_CTLCH', 'ON' )
rc = RxCommOpen( comPort, 9600, '8N1', 'NONE' )
IF rc <> 0 THEN
DO
    SAY 'Cannot Open COM Port!!'
    EXIT
END

/*--------------------------------------------------------*/
/**
 * Execute a command to check connection.
 */
DO FOREVER
    rc = RxCommWrite( '\r\r/c\r' )
    DO FOREVER
        rc = RxCommRead( 100 ) /* Wait for a minute to recieve any character */
        IF rc = '' THEN LEAVE  /* Initiate if cannot recieve any character */

        DO WHILE POS( '0D'x, rc ) > 0
            rc = DELSTR( rc, POS( '0D'x, rc ), 1 )
        END
        DO WHILE POS( '0A'x, rc ) > 0
            rc = DELSTR( rc, POS( '0A'x, rc ), 1 )
        END
        IF rc <> '' THEN LEAVE
    END
    IF POS( 'Ok', rc ) = 1 THEN LEAVE

    /**
     * Initiate the 'Crossam2+'.
     */
    DO FOREVER
        SAY 'Push [REC] + [POWER] + [F14] keys of the Crossam2+.'
        rc = RxCommRead() /* Wait to recieve any character */
        IF POS( 'GO', rc ) > 0 THEN LEAVE
    END

    IData.1  = 'A2 10 BD 23 10 9D 00 01 CA 10 F7 A2 40 BD 33 10'x
    IData.2  = '9D 00 0B CA 10 F7 3C 00 2B 3C 00 2C 3C 32 06 58'x
    IData.3  = '4C 00 0B 7F D7 3C 80 DF 8F DE 42 EA 20 58 C4 4C'x
    IData.4  = '15 0B 00 4F FE 6F FF 8F FE 3C 00 DA CF DA 64 06'x
    IData.5  = 'D0 05 6F FE 4C 00 01 C2 9F FE 7F FF 20 EE C0 20'x
    IData.6  = 'C8 C5 9F FC 20 2A 0B A5 25 D0 ED 80 D6 A7 23 01'x
    IData.7  = '60 BF 23 3C 00 2A A2 00 20 44 CD C9 2F D0 F1 E8'x
    IData.8  = '4C 9E C9 FF FF FF FF FF FF FF FF FF FF FF FF FF'x
    IData.9  = 'FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF'x
    IData.10 = 'FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF'x
    IData.11 = 'FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF'x
    IData.12 = 'FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF'x
    IData.13 = 'FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF'x
    IData.14 = 'FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF'x
    IData.15 = 'FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF'x
    IData.16 = 'FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF FF'x
    IniComData = ''
    DO i = 1 to 16
        IniComData = IniComData || IData.i
    END
    rc = RxCommWrite( IniComData )
END

SAY 'Complete to connect the Crossam2+!!'

/*--------------------------------------------------------*/
/**
 * Execute a command
 */
DO FOREVER
    SAY 'Input the number of Dial-key(0`40/[RET]:QUIT).'
    PULL dialKey
    IF '' == dialKey THEN LEAVE

    rc = RxCommWrite( '\r/t0,' || dialKey || '\r\r' )
    DO FOREVER
        rc = RxCommRead() /* Wait to recieve any character */
        DO WHILE POS( '0D'x, rc ) > 0
            rc = DELSTR( rc, POS( '0D'x, rc ), 1 )
        END
        DO WHILE POS( '0A'x, rc ) > 0
            rc = DELSTR( rc, POS( '0A'x, rc ), 1 )
        END
        IF rc <> '' THEN LEAVE
    END
    IF POS( 'Ok', rc ) = 1 THEN SAY 'Communication is success!!'
    IF POS( 'Ng', rc ) = 1 THEN SAY 'Communication is Failure!!'
END

rc = RxCommClose()

EXIT
