/***
 * REXX Communication Control Function Library  Ver.1.9
 *                  copyright 1998-2002, Naga(Kazuo Adachi)
 *                          mailto:nagaw@attglobal.net
 *
 * $Id$
 *
 * $Log$
 */

#ifndef _IO_ASYNC_H_
#define _IO_ASYNC_H_

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */


/*--------------------------------------------------------*/
/***
 * Extend ASYNC Device I/O Controls.
 */
#pragma pack(1)

/* ASYNC_GETCOMMEVENT */
#define READ_TIMEOUT            0x0002

/* fbFlowReplace */
#define MODE_FULL_DUPLEX        0x20

/* fbTimeout */
#define MODE_NOUSE_HW_BUFFER    0x08
#define MODE_USE_HW_BUFFER      0x10
#define MODE_PROTO_OVERRIDE     0x18
#define MODE_READ_TRIGGER1      0x00
#define MODE_READ_TRIGGER4      0x20
#define MODE_READ_TRIGGER8      0x40
#define MODE_READ_TRIGGER14     0x60
#define MODE_WRITE_BUFFER16     0x80

/* bParity */
#define PARITY_NONE             0x00
#define PARITY_ODD              0x01
#define PARITY_EVEN             0x02
#define PARITY_MARK             0x03
#define PARITY_SPACE            0x04

/* bStopBits */
#define STOPBITS_ONE            0x00
#define STOPBITS_ONE_HALF       0x01
#define STOPBITS_TWO            0x02

/**
 * Extented Set Baudrate.
 */
typedef struct  _ExtSetBaud
{
    ULONG   ulBaud;
    UCHAR   ucBaud;

} EXSETBAUD, *PEXSETBAUD;

/**
 * Extented Query Baudrate.
 */
typedef struct  _ExtGetBaud
{
    ULONG   ulBaud;
    UCHAR   ucBaud;
    ULONG   ulMin;
    UCHAR   ucMin;
    ULONG   ulMax;
    UCHAR   ucMax;

} EXGETBAUD, *PEXGETBAUD;

/**
 * Enhanced Mode Parameter.
 */
typedef struct  _ExtModeParam
{
    BYTE    fbDma;
    ULONG   ulReserved;

} EXMODEPRM, *PEXMODEPRM;

/* fbDma */
#define MODE_SUPPORT_ENH        0x01
#define MODE_ENHANCED           0x02
#define MODE_RECV_DMA           0x04
#define MODE_RECV_DMA_ONLY      0x08
#define MODE_SEND_DMA           0x10
#define MODE_SEND_DMA_ONLY      0x20
#define MODE_DMA_RECV_CTL       0x40
#define MODE_DMA_SEND_CTL       0x80

#pragma pack()


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* _IO_ASYNC_H_ */
